/** =================================================================\n
 *
 * Curve Compression Project - CS 7491 2004 project 1\n
 * @file PolygonalCurve.cpp
 *
 * Primary Authors: Nguyen Truong (nltruong@cc.gatech.edu)\n
 *                  Howard Zhou (howardz@cc.gatech.edu)\n
 *
 * (C) Copyright 2004\n
 * (C) Copyright Georgia Institute of Technology, 2004\n
 *
 * ==================================================================\n
 * Basic Polygonal Curve class implementation
 *
 * @version 1.0\n
 *     Initial Revision
 * @date 2004-01-24
 * @author Nguyen Truong & Howard Zhou
 *
 *
 * @todo
 * @bug
 * @warning 
 *
 * ===================================================================\n
 */
#pragma warning(disable : 4786)

#include <stdio.h>
#include <stdlib.h>
// #include <math.h>

#include "PolygonalCurve.h"

// #include "common.h"

/// @namespace using standard namespace
using namespace std;

// ==================================================================================
/**
 * @class CPolygonalCurve
 * @brief General polygonal curve class implementation
 * @ingroup Curve
 *
 * @par requirements
 *
 * @par license
 * This code is absolutely free to use and modify. The code is provided "as is" with
 * no expressed or implied warranty. The author accepts no liability if it causes
 * any damage to your computer, causes your pet to fall ill, increases baldness
 * or makes your car start emitting strange noises when you start it up.
 * This code has no bugs, just undocumented features!
 *
 * 
 * @version 1.0\n
 *     Initial Revision
 * @date 2004-01-24
 * @author Nguyen Truong & Howard Zhou
 *
 * This class is a general polygonal curve class
 * 
 * @todo
 * @bug
 * @warning
 */
// ================================================================================


/**
 * operator <<:
 * Display polygonal curve (a list of vertices) through the ostream
 * @param os reference to the ostream object
 * @param polyCurve reference to the curve
 * @return ostream with the new stream of curve contents attached
 */
/*
ostream& operator<< (ostream& os, CPolygonalCurve& polyCurve)
{
	assert(polyCurve.isValid());
	
	vector<CPoint2DReal>::iterator curr;
	for(curr = polyCurve._vertices.begin(); curr != polyCurve._vertices.end(); curr++)
	{
		CPoint2DReal p = *curr;
		cout << p << " -> ";
	}
	return os;
}
*/

/**
 * readFile
 * Read in the file, recording the number of vertices, the number
 * of edges (if the two are equal, it's a close curve, otherwise
 * it's an open curve), the number of bits used for x-coor, the
 * number of bits used for y-coor, and the x,y-coordinates for
 * all vertices
 *
 * @param filename constant string file name
 * @return
 */
/*
void CPolygonalCurve::readFile(const char * filename)
{
	FILE * inFile;
	char line[255];
	long nVertices;
	double x, y;
	int i;

	_minX = LONG_MAX;
	_maxX = LONG_MIN;
	_minY = LONG_MAX;
	_maxY = LONG_MIN;

	if(NULL == (inFile = fopen(filename, "rb")))
	{
		cout << "Error -- unable to open file <" << filename << ">\n";
		exit(-1);
	}

	
	if(NULL == fgets(line, 255, inFile) || (nVertices = atol(line)) == 0)
	{
		cout << "Error -- wrong file format\n";
		exit(-1);
	}

	for(i = 0; i < nVertices; i++)
	{

		if (2 != fscanf(inFile, "%lf %lf\n", &x, &y))
		{
			cout << "Error -- wrong vertex\n";
			exit(-1);
		}
			
		if (x < _minX)
			_minX = x;
		if (x > _maxX)
			_maxX = x;
		if (y < _minY)
			_minY = y;
		if (y > _maxY)
			_maxY = y;

		_vertices.push_back(CPoint2D<double>(x, y));
	}
}
*/

/**
 * writeFile
 * write the curve from a file
 * @param filename constant string file name
 * @return
 */
/*
void CPolygonalCurve::writeFile(const char * filename)
{

}
*/


