/*
	compression base class all others will derive from this.
    contains the bitwise file I/O routines...Uses ::bit_file
    to accomplish this, even for files that are doing bitwise
    output.
*/
#ifndef _COMPRESS_H
	#define _COMPRESS_H
#ifndef _MSTRING_H
	#include "mstring.h"
#endif
#ifndef _INC_STDIO
	#include <stdio.h>
#endif
#ifndef __IOSTREAM_H
	#include <iostream>
#endif
#ifndef __BITFILE_H
	#include "bitfile.h"
#endif

using namespace std;

class Compress	{
public:
	 Compress () { typeChar = '.'; }
   ~ Compress () {}
virtual	void CompressFile( String &input, String &output ) {}
virtual void ExpandFile( String &input, String &output ) {}
	bit_file *OpenInputBitFile( String &name );
	bit_file *OpenOutputBitFile( String &name );
	void     CloseInputBitFile(bit_file *m);
	void     CloseOutputBitFile(bit_file *m);

protected:
	int      OutputStd( int bit, bit_file *m );
	void     OutputBit( bit_file &m,int bit );
	void     OutputBits( bit_file &m,unsigned long code, int count );
	int      InputStd(bit_file *m);
	int      InputBit(bit_file &m);
	unsigned long InputBits( bit_file &m, int bit_count );

	char	 typeChar;
};
#endif
